import pygame

##Takes input of the starting x coords, the barrier x coords and the pygame text surface.
##It returns the x coord that you should blit the text at to get it right aligned or center aligned depending on what you call.

def Right (self,xstart,xbarrier,textsurface):
	textlength = textsurface.get_width()
	spacelength = abs(xbarrier-xstart)
	if spacelength > textlength:
		offset = abs(spacelength - textlength)
		newx = xstart + offset
		return newx
	else:
		return xstart
	
def Center (self,xstart,xbarrier,textsurface):
	textlength = textsurface.get_width()
	spacelength = abs(xbarrier-xstart)
	if spacelength > textlength:
		offset = abs(spacelength - textlength)/2
		newx = xstart + offset
		return newx
	else:
		return xstart

def VCenter (self,ystart,ybarrier,textsurface):
	textheight = textsurface.get_height()
	spaceheight = abs(ybarrier-ystart)
	if spaceheight > textheight:
		offset = abs(spaceheight - textheight)/2
		newy = ystart + offset
		return newy
	else:
		return ystart

def ShortenText (self,xstart,xbarrier,textsurface,string,font,special=1,color=(0,0,0)):
	textlength = textsurface.get_width()
	spacelength = abs(xbarrier-xstart)
	if spacelength > textlength:
		return font.render(string,1,color)
	else:
		stringlist = string.split(" ")
		if stringlist[len(stringlist)-(1+special)] == "Jr." or stringlist[len(stringlist)-(1+special)] == "Sr.":
			stringlist.pop(len(stringlist)-(1+special))
		else:
			pass
		if len(stringlist) > 2+special:
			count = 1
			max = len(stringlist)-(1+special)
			while count < max:
				newname = stringlist[count][0]+"."
				stringlist[count] = newname
				count = count + 1
			newstring = ""
			for item in stringlist:
				newstring = newstring + item + " "
			newstring = newstring.rstrip(" ")
			newtextsurface = font.render(newstring,1,color)
			if spacelength > newtextsurface.get_width():
				return newtextsurface
			else:
				stringlist[0] = stringlist[0][0]+"."
		else:
			stringlist[0] = stringlist[0][0]+"."
		newstring = ""
		for item in stringlist:
			newstring = newstring + item + " "
		newstring = newstring.rstrip(" ")
		newtextsurface = font.render(newstring,1,color)
		if spacelength > newtextsurface.get_width():
			return newtextsurface
		else:
			lastname = stringlist[len(stringlist)-(1+special)]
			lastnamelength = len(lastname)
			count = 0
			namelist = []
			while count < lastnamelength:
				namelist.append(lastname[count])
				count = count + 1
			count = 1
			while count <= lastnamelength:
				if count < 3:
					namelist[lastnamelength-count] = "."
				else:
					namelist[lastnamelength-count] = ""
				if count > 2:
					stringlist[len(stringlist)-(1+special)] = ""
					for item in namelist:
						stringlist[len(stringlist)-(1+special)] = stringlist[len(stringlist)-(1+special)] + item
					newstring = ""
					for item in stringlist:
						newstring = newstring + item + " "
					newstring = newstring.rstrip(" ")
					newtextsurface = font.render(newstring,1,color)
					if spacelength > newtextsurface.get_width():
						return newtextsurface
					else:
						pass
				else:
					pass
				count = count + 1
			return newtextsurface
			
def Truncate (self,xstart,xbarrier,textsurface,string,font,special=1,color=(0,0,0)):
	textlength = textsurface.get_width()
	spacelength = abs(xbarrier-xstart)
	if spacelength >= textlength:
		return textsurface
	else:
		while spacelength < textlength:
			string = string[:-1]
			textsurface = font.render(string,1,color)
			textlength = textsurface.get_width()
		return textsurface

def Multiline (self,xstart,xbarrier,textsurface,string,font,color):
    textlength = textsurface.get_width()
    spacelength = abs(xbarrier-xstart)
    newtextlength = 1000000
    if spacelength >= textlength:
        return [textsurface]
    else:
        textlist = []
        while spacelength < textlength:
            newstring = string
            newtextlength = 1000000
            while spacelength < newtextlength:
                char = newstring[len(newstring)-1]
                newstring = newstring[:-1]
                if char == " ":
                    newtextsurface = font.render(newstring,1,color)
                    newtextlength = newtextsurface.get_width()
                else:
                    pass
            textlist.append(newtextsurface)
            string = string.replace(newstring+" ","")
            textsurface = font.render(string,1,color)
            textlength = textsurface.get_width()
        textlist.append(textsurface)
        return textlist
