import random

def GenerateVoter(dlevel,rlevel,base,target):
    dtarget = int(round(target*(.5-base/100.0)))
    rtarget = int(round(target*(.5+base/100.0)))
    voters = []
    ##Decide Liberal distribution
    gen = 0
    while gen < dtarget:
        count = 0
        idlist = []
        while count < 5:
            ideology = int(round(random.gauss(-25-(dlevel-1)*5,20)))
            if ideology < -50:
                ideology = -50
            else:
                pass
            idlist.append(ideology)
            count = count + 1
        voters.append(idlist)
        gen = gen + 1
    ##Decide Conservative distribution
    gen = 0
    while gen < rtarget:
        count = 0
        idlist = []
        while count < 5:
            ideology = int(round(random.gauss(25+(rlevel-1)*5,20)))
            if ideology > 50:
                ideology = 50
            else:
                pass
            count = count + 1
            idlist.append(ideology)
        voters.append(idlist)
        gen = gen + 1
    return voters

def MakePartisanLists(voters):
    votedem = 0
    voterep = 0
    dempartisans = []
    reppartisans = []
    nonpartisans = []
    count = 0
    limit = 80
    ##Decide which people are partisans (based on the party platform)
    index = 0
    for v in voters:
        rdiff1 = abs(v[0] - 50)
        rdiff2 = abs(v[1] - 50)
        rdiff3 = abs(v[2] - 50)
        rdiff4 = abs(v[3] - 50)
        rdiff5 = abs(v[4] - 50)
        rdiff = rdiff1+rdiff2+rdiff3+rdiff4+rdiff5
        ddiff1 = abs(v[0] + 50)
        ddiff2 = abs(v[1] + 50)
        ddiff3 = abs(v[2] + 50)
        ddiff4 = abs(v[3] + 50)
        ddiff5 = abs(v[4] + 50)
        ddiff = ddiff1+ddiff2+ddiff3+ddiff4+ddiff5
        if rdiff < limit:
            reppartisans.append(index)
        elif ddiff < limit:
            dempartisans.append(index)
        else:
            nonpartisans.append(index)
        index = index + 1
    return [dempartisans,reppartisans,nonpartisans]

def GeneralElection(wave,dorg,rorg,dchr,rchr,dcam,rcam,r,d,voters,dempartisanlist,reppartisanlist,nonpartisanlist,target):
    returnlist = []
    index = 0
    for election in r:
        voterep = 0
        votedem = 0
        if r[index] != "null" and d[index] != "null":
            voterindexlist = []
            dempercent = (100.0*len(dempartisanlist)/len(voters)+(dcam-rcam)+(dorg-rorg)+(dchr[index]-rchr[index])-wave)/100.0
            reppercent = (100.0*len(reppartisanlist)/len(voters)+(rcam-dcam)+(rorg-dorg)+(rchr[index]-dchr[index])+wave)/100.0
            dplist = []
            rplist = []
            nplist = []
            for p in dempartisanlist:
                dplist.append(p)
            for p in reppartisanlist:
                rplist.append(p)
            for p in nonpartisanlist:
                nplist.append(p)
            #Randomize Turnout based on these percentages
            while len(voterindexlist) < target:
                pick = random.random()
                if pick <= dempercent:
                    if len(dplist) > 0:
                        pick2 = random.randint(0,len(dplist)-1)
                        v = dplist.pop(pick2)
                        voterindexlist.append(v)
                    else:
                        pass
                elif pick <= reppercent+dempercent:
                    if len(rplist) > 0:
                        pick2 = random.randint(0,len(rplist)-1)
                        v = rplist.pop(pick2)
                        voterindexlist.append(v)
                    else:
                        pass
                else:
                    if len(nplist) > 0:
                        pick2 = random.randint(0,len(nplist)-1)
                        v = nplist.pop(pick2)
                        voterindexlist.append(v)
                    else:
                        pass
            voterlist = []
            for i in voterindexlist:
                voterlist.append(voters[i])
            for v in voterlist:
                rdiff1 = abs(v[0] - r[index][0])
                rdiff2 = abs(v[1] - r[index][1])
                rdiff3 = abs(v[2] - r[index][2])
                rdiff4 = abs(v[3] - r[index][3])
                rdiff5 = abs(v[4] - r[index][4])
                rdiff = rdiff1 + rdiff2 + rdiff3 + rdiff4 + rdiff5
                ddiff1 = abs(v[0] - d[index][0])
                ddiff2 = abs(v[1] - d[index][1])
                ddiff3 = abs(v[2] - d[index][2])
                ddiff4 = abs(v[3] - d[index][3])
                ddiff5 = abs(v[4] - d[index][4])
                ddiff = ddiff1 + ddiff2 + ddiff3 + ddiff4 + ddiff5
                if rdiff < ddiff:
                    voterep = voterep + 1
                elif ddiff < rdiff:
                    votedem = votedem + 1
                else:
                    #Break Tie
                    flip = random.randint(0,1)
                    if flip == 0:
                        voterep = voterep + 1
                    else:
                        votedem = votedem + 1
        else:
            if r[index] == "null" and d[index] != "null":
                votedem = target
            elif d[index] == "null" and r[index] != "null":
                voterep = target
            else:
                pass
        index = index + 1
        returnlist.append([votedem,voterep])
    return(returnlist)

def PrimaryElection(echr,mchr,e,m,voters,partisanlist,nonpartisanlist,target):
    ##Limit it to only two candidates in each election to make it easier
    ##Seperate it out as more liberal/conservative, more moderate (makes it easier for the mapping and everything else)
    ##e == extreme (thought not necessarily of course!)
    ##m == moderate (relatively at least!)
    ##partisanlist == either dempartisanlist or reppartisanlist depending on which primary it is
    ##nonpartisanlist == the nonpartisans that will be more moderate
    ##target == the number of total voters that turnout, probably 15% for nonpresidential primaries, 25% for presidential primaries  (150, 250)
    returnlist = []
    index = 0
    for election in e:
        voteext = 0
        votemod = 0
        if e[index] != "null" and m[index] != "null":
            voterindexlist = []
            extpercent = (100.0*len(partisanlist)/(len(partisanlist)+len(nonpartisanlist)/2.0)+(echr[index]-mchr[index]))/100.0
            plist = []
            nplist = []
            for p in partisanlist:
                plist.append(p)
            for p in nonpartisanlist:
                nplist.append(p)
            #Randomize Turnout based on these percentages
            while len(voterindexlist) < target:
                pick = random.random()
                if pick <= extpercent:
                    if len(plist) > 0:
                        pick2 = random.randint(0,len(plist)-1)
                        v = plist.pop(pick2)
                        voterindexlist.append(v)
                    else:
                        pass
                else:
                    if len(nplist) > 0:
                        pick2 = random.randint(0,len(nplist)-1)
                        v = nplist.pop(pick2)
                        voterindexlist.append(v)
                    else:
                        pass
            voterlist = []
            for i in voterindexlist:
                voterlist.append(voters[i])
            for v in voterlist:
                ediff1 = abs(v[0] - e[index][0])
                ediff2 = abs(v[1] - e[index][1])
                ediff3 = abs(v[2] - e[index][2])
                ediff4 = abs(v[3] - e[index][3])
                ediff5 = abs(v[4] - e[index][4])
                ediff = ediff1 + ediff2 + ediff3 + ediff4 + ediff5 + 100 + 50*(mchr[index]-echr[index])
                mdiff1 = abs(v[0] - m[index][0])
                mdiff2 = abs(v[1] - m[index][1])
                mdiff3 = abs(v[2] - m[index][2])
                mdiff4 = abs(v[3] - m[index][3])
                mdiff5 = abs(v[4] - m[index][4])
                mdiff = mdiff1 + mdiff2 + mdiff3 + mdiff4 + mdiff5
                if ediff < mdiff:
                    voteext = voteext + 1
                elif mdiff < mdiff:
                    votemod = votemod + 1
                else:
                    #Break Tie
                    flip = random.randint(0,1)
                    if flip == 0:
                        voteext = voteext + 1
                    else:
                        votemod = votemod + 1
        else:
            if e[index] == "null" and m[index] != "null":
                votemod = target
            elif m[index] == "null" and e[index] != "null":
                voteext = target
            else:
                pass
        index = index + 1
        returnlist.append([voteext,votemod])
    return(returnlist)
